// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert
// Copyright 2014, Will Godfrey   

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is derivative of ZynAddSubFX original code, modified September 2014

// generated by Fast Light User Interface Designer (fluid) version 1.0303

#include "/builddir/build/BUILD/yoshimi-1.3.4/src/ConfigUI.h"
#include "Misc/SynthEngine.h"
#include "Misc/Bank.h"
#include "MasterUI.h"

void ConfigUI::cb_configwindow_i(Fl_Double_Window* o, void*) {
  o->hide();
}
void ConfigUI::cb_configwindow(Fl_Double_Window* o, void* v) {
  ((ConfigUI*)(o->user_data()))->cb_configwindow_i(o,v);
}

void ConfigUI::cb_OscilSize_i(Fl_Choice* o, void*) {
  //
		unsigned int tmp = synth->getRuntime().Oscilsize;
                synth->getRuntime().Oscilsize = 128 << o->value();
                if (synth->getRuntime().Oscilsize != tmp)
                	configChanged = true;
}
void ConfigUI::cb_OscilSize(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_OscilSize_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_OscilSize[] = {
 {"128", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"256", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"512", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"1024", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"2048", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"4096", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"8192", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {"16384", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_PADsynth_i(Fl_Choice* o, void*) {
  //
                int tmp = synth->getRuntime().Interpolation;
                synth->getRuntime().Interpolation = (int) o->value();
                if (synth->getRuntime().Interpolation != tmp)
                	configChanged = true;
}
void ConfigUI::cb_PADsynth(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_PADsynth_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_PADsynth[] = {
 {"Linear(fast)", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Cubic(slow)", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_Virtual_i(Fl_Choice* o, void*) {
  //
                int tmp = synth->getRuntime().VirKeybLayout;
                synth->getRuntime().VirKeybLayout = (int) o->value();
                if (synth->getRuntime().VirKeybLayout != tmp)
                	configChanged = true;
}
void ConfigUI::cb_Virtual(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Virtual_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_Virtual[] = {
 {" ", 0,  0, 0, 1, FL_NORMAL_LABEL, 1, 11, 0},
 {"QWERTY", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 11, 0},
 {"Dvorak", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 11, 0},
 {"QWERTZ", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 11, 0},
 {"AZERTY", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 11, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_SessionStateFile_i(Fl_Input* o, void*) {
  //
              synth->getRuntime().StateFile = string(o->value());
              SessionStateFile->changed();
}
void ConfigUI::cb_SessionStateFile(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_SessionStateFile_i(o,v);
}

void ConfigUI::cb_StateFileButton_i(Fl_Button*, void*) {
  //
                const char *filename = fl_file_chooser("Nominate session save state file",
                                                       NULL, synth->getRuntime().StateFile.c_str(), 0);
                if (NULL != filename)
                {
                    synth->getRuntime().StateFile = string(filename);
                    SessionStateFile->value(synth->getRuntime().StateFile.c_str());
                    SessionStateFile->changed();
                    configChanged = true;
                };
}
void ConfigUI::cb_StateFileButton(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_StateFileButton_i(o,v);
}

void ConfigUI::cb_compression_i(Fl_Counter* o, void*) {
  //
		unsigned int tmp = synth->getRuntime().GzipCompression;
		synth->getRuntime().GzipCompression = (unsigned int) o->value();
		if(synth->getRuntime().GzipCompression != tmp)
			configChanged = true;
}
void ConfigUI::cb_compression(Fl_Counter* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_compression_i(o,v);
}

void ConfigUI::cb_Send_i(Fl_Choice* o, void*) {
  synth->getRuntime().consoleMenuItem = o->value();
if (o->value())
    synth->getGuiMaster()->Reports->activate();
else
{
    synth->getGuiMaster()->Reports->deactivate();
    synth->getGuiMaster()->yoshiLog->Hide();
};
}
void ConfigUI::cb_Send(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Send_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_Send[] = {
 {"stderr", 0,  0, 0, 0, FL_NORMAL_LABEL, 0, 12, 0},
 {"Console Window", 0,  0, 0, 0, FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_presetbrowse_i(Fl_Browser* o, void*) {
  activatebutton_presetdir(o->value() != 0);
}
void ConfigUI::cb_presetbrowse(Fl_Browser* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_presetbrowse_i(o,v);
}

void ConfigUI::cb_Add_i(Fl_Button*, void*) {
  //
                const char *dirname;
                dirname = fl_dir_chooser("Add a preset directory :", NULL, 0);
                if (!dirname)
                    return;
                presetbrowse->add(dirname);
                configChanged = true;
}
void ConfigUI::cb_Add(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Add_i(o,v);
}

void ConfigUI::cb_removepresetbutton_i(Fl_Button*, void*) {
  //
                if (presetbrowse->value() != 0)
                {
                    presetbrowse->remove(presetbrowse->value());
                }
                activatebutton_presetdir(false);
                configChanged = true;
}
void ConfigUI::cb_removepresetbutton(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_removepresetbutton_i(o,v);
}

void ConfigUI::cb_makedefaultpresetbutton_i(Fl_Button*, void*) {
  //
                int n = presetbrowse->value();
                if (n != 0)
                {
                    presetbrowse->move(1, n);
                    presetbrowse->value(1);
                    presetbrowse->redraw();
                }
                activatebutton_presetdir(true);
                configChanged = true;
}
void ConfigUI::cb_makedefaultpresetbutton(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_makedefaultpresetbutton_i(o,v);
}

void ConfigUI::cb_Jack_i(Fl_Input* o, void*) {
  //
                synth->getRuntime().jackServer = string(o->value());
                configChanged = true;
}
void ConfigUI::cb_Jack(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Jack_i(o,v);
}

void ConfigUI::cb_Alsa_i(Fl_Input* o, void*) {
  //
                synth->getRuntime().alsaMidiDevice = string(o->value());
                configChanged = true;
}
void ConfigUI::cb_Alsa(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Alsa_i(o,v);
}

void ConfigUI::cb_Alsa1_i(Fl_Input* o, void*) {
  //
                synth->getRuntime().alsaAudioDevice = string(o->value());
                configChanged = true;
}
void ConfigUI::cb_Alsa1(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Alsa1_i(o,v);
}

void ConfigUI::cb_Samplerate_i(Fl_Check_Browser* o, void*) {
  //
                int chk = o->value();
                if (o->nchecked() < 1)
                    o->set_checked(chk = 2);
                else if (o->nchecked() > 1)
                {
                    if (!chk)
                        chk = 2;
                    o->check_none();
                    o->set_checked(chk);
                }
                unsigned int sample_rate;
                switch (chk)
                {
                    case 1:
                        sample_rate = 96000;
                        break;
                    case 3:
                        sample_rate = 44100;
                        break;
                    case 2:
                    default:
                        sample_rate = 48000;
                        break;
                }
                synth->getRuntime().Samplerate = sample_rate;
                configChanged = true;
}
void ConfigUI::cb_Samplerate(Fl_Check_Browser* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Samplerate_i(o,v);
}

void ConfigUI::cb_Period_i(Fl_Check_Browser* o, void*) {
  //
                int chk = o->value();
                if (o->nchecked() < 1)
                    o->set_checked(4);
                else if (o->nchecked() > 1)
                {
                    if (!chk)
                        chk = 3;
                    o->check_none();
                    o->set_checked(chk);
                }
                int buff_size;
                switch (chk)
                {
                    case 1: buff_size = 64; break;
                    case 2: buff_size = 128; break;
                    case 3: buff_size = 256; break;
                    case 4: buff_size = 512; break;
                    case 5: buff_size = 1024; break;
                    default: buff_size = 512; break;
                }
                synth->getRuntime().Buffersize = buff_size;
                configChanged = true;
}
void ConfigUI::cb_Period(Fl_Check_Browser* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Period_i(o,v);
}

void ConfigUI::cb_CCs_i(Fl_Group*, void*) {
  //
    EPCvalue = synth->getRuntime().midi_upper_voice_C;
    if (EPCvalue >= 128)
    {
        EPCspinner->value(110);
        EPCspinner->deactivate();
    }
    else
    {
        EPCspinner->value(EPCvalue);
        EPCspinner->activate();
    }
    
    BankRootvalue = synth->getRuntime().midi_bank_root;
    if (BankRootvalue >= 128)
    {
        BankRoot->value(0);
        BankRoot->deactivate();
    }
    else
    {
        BankRoot->value(BankRootvalue);
        BankRoot->activate();
    };
}
void ConfigUI::cb_CCs(Fl_Group* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->user_data()))->cb_CCs_i(o,v);
}

void ConfigUI::cb_BankRootok_i(Fl_Return_Button* o, void*) {
  //
    int candidate = BankRoot->value();
    if (candidate == BankRootvalue)
    {
        o->deactivate();
        return;
    }
    string name = synth->getRuntime().testCCvalue(candidate);
    if (!name.empty())
    {
        fl_alert("In use for %s",name.c_str());
        if ( BankRootvalue < 128)
        {
            BankRoot->value(BankRootvalue);
            BankRoot->redraw();
        }
    }
    else
    {
        synth->getRuntime().midi_bank_root = candidate;
        BankRootvalue = candidate;
        o->deactivate();
        configChanged = true;
    };
}
void ConfigUI::cb_BankRootok(Fl_Return_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_BankRootok_i(o,v);
}

void ConfigUI::cb_BankRoot_i(Fl_Spinner*, void*) {
  BankRootok->activate();
}
void ConfigUI::cb_BankRoot(Fl_Spinner* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_BankRoot_i(o,v);
}

void ConfigUI::cb_Enable_i(Fl_Check_Button* o, void*) {
  //
    if (o->value() == 0)
    {
         synth->getRuntime().midi_bank_root = 128;
         BankRoot->value(0);
         BankRoot->deactivate();
    }
    else
    {
         BankRoot->activate();
         BankRoot->value(0);
    }
    BankRoot->redraw();
    configChanged = true;
}
void ConfigUI::cb_Enable(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Enable_i(o,v);
}

void ConfigUI::cb_bankchange_i(Fl_Choice* o, void*) {
  //
    int tmp = synth->getRuntime().midi_bank_C;
    int candidate;
    switch (o->value())
    {
        case 0:
            candidate = 32;
            break;
        case 1:
            candidate = 0;
            break;
        default:
            candidate = 128;
    }
    if (candidate == tmp)
        return;
    string name = synth->getRuntime().testCCvalue(candidate);
    if (name.empty())
        synth->getRuntime().midi_bank_C = candidate;
    else
    {
    	o->value(oldBank);
    	o->redraw();
        fl_alert("In use for %s",name.c_str());
    }
    if (synth->getRuntime().midi_bank_C == tmp)
        configChanged = true;
}
void ConfigUI::cb_bankchange(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_bankchange_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_bankchange[] = {
 {"LSB", 0,  0, 0, 0, FL_NORMAL_LABEL, 0, 12, 0},
 {"MSB", 0,  0, 0, 0, FL_NORMAL_LABEL, 0, 12, 0},
 {"Off", 0,  0, 0, 0, FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* ConfigUI::banklsb = ConfigUI::menu_bankchange + 0;
Fl_Menu_Item* ConfigUI::bankusb = ConfigUI::menu_bankchange + 1;
Fl_Menu_Item* ConfigUI::bankoff = ConfigUI::menu_bankchange + 2;

void ConfigUI::cb_Enable1_i(Fl_Check_Button* o, void*) {
  //
		int tmp = synth->getRuntime().EnableProgChange;
		synth->getRuntime().EnableProgChange = o->value();
		if (synth->getRuntime().EnableProgChange != tmp)
			configChanged = true;
}
void ConfigUI::cb_Enable1(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Enable1_i(o,v);
}

void ConfigUI::cb_Enable2_i(Fl_Check_Button* o, void*) {
  //
		int tmp = synth->getRuntime().enable_part_on_voice_load;
		synth->getRuntime().enable_part_on_voice_load = o->value();
		if (synth->getRuntime().enable_part_on_voice_load != tmp)
			configChanged = true;
}
void ConfigUI::cb_Enable2(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Enable2_i(o,v);
}

void ConfigUI::cb_EPCok_i(Fl_Return_Button* o, void*) {
  //
    int candidate = EPCspinner->value();
    if (candidate == EPCvalue)
    {
        o->deactivate();
        return;
    }


    string name = synth->getRuntime().testCCvalue(candidate);
    if (!name.empty())
    {
        fl_alert("In use for %s",name.c_str());
        if (EPCvalue < 128)
        {
        EPCspinner->value(EPCvalue);
        EPCspinner->redraw();
        }
    }
    else
    {
        synth->getRuntime().midi_upper_voice_C = candidate;
        EPCvalue = candidate;
        o->deactivate();
        configChanged = true;
    };
}
void ConfigUI::cb_EPCok(Fl_Return_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_EPCok_i(o,v);
}

void ConfigUI::cb_EPCspinner_i(Fl_Spinner*, void*) {
  EPCok->activate();
}
void ConfigUI::cb_EPCspinner(Fl_Spinner* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_EPCspinner_i(o,v);
}

void ConfigUI::cb_Enable3_i(Fl_Check_Button* o, void*) {
  //
    if (o->value() == 0)
    {
         synth->getRuntime().midi_upper_voice_C = 128;
         EPCspinner->value(110);
         EPCspinner->deactivate();
    }
    else
    {
         EPCspinner->activate();
         EPCspinner->value(110);
    }
    EPCspinner->redraw();
    configChanged = true;
}
void ConfigUI::cb_Enable3(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Enable3_i(o,v);
}

void ConfigUI::cb_Close_i(Fl_Button*, void*) {
  synth->getGuiMaster()->bankui->readbankcfg();
configwindow->do_callback();
}
void ConfigUI::cb_Close(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_Close_i(o,v);
}

void ConfigUI::cb_Save_i(Fl_Button*, void*) {
  savesettings();
synth->getGuiMaster()->bankui->readbankcfg();
configChanged = false;
configwindow->do_callback();
}
void ConfigUI::cb_Save(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_Save_i(o,v);
}

Fl_Double_Window* ConfigUI::make_window() {
  { configwindow = new Fl_Double_Window(465, 330, "Yoshimi Settings");
    configwindow->callback((Fl_Callback*)cb_configwindow, (void*)(this));
    { Fl_Tabs* o = new Fl_Tabs(5, 5, 455, 297);
      { Fl_Group* o = new Fl_Group(5, 25, 455, 277, "Main settings");
        o->labelsize(12);
        o->hide();
        { Fl_Choice* o = new Fl_Choice(250, 50, 100, 20, "OscilSize");
          o->tooltip("ADSynth Oscillator Size (samples)");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(12);
          o->textsize(11);
          o->callback((Fl_Callback*)cb_OscilSize);
          o->menu(menu_OscilSize);
          o->value( (int)(logf(synth->getRuntime().Oscilsize / 128.0f - 1.0f) / logf(2.0f)) + 1);
        } // Fl_Choice* o
        { Fl_Choice* o = new Fl_Choice(250, 130, 100, 20, "PADsynth Interpolation");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_PADsynth);
          o->menu(menu_PADsynth);
          o->value(synth->getRuntime().Interpolation);
        } // Fl_Choice* o
        { Fl_Choice* o = new Fl_Choice(250, 90, 100, 20, "Virtual Keyboard Layout");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(12);
          o->textfont(1);
          o->textsize(13);
          o->callback((Fl_Callback*)cb_Virtual);
          o->menu(menu_Virtual);
          o->value(synth->getRuntime().VirKeybLayout);
        } // Fl_Choice* o
        { Fl_Input* o = SessionStateFile = new Fl_Input(160, 247, 220, 20, "Session state save file");
          SessionStateFile->labelsize(12);
          SessionStateFile->textsize(12);
          SessionStateFile->callback((Fl_Callback*)cb_SessionStateFile);
          SessionStateFile->when(FL_WHEN_CHANGED);
          o->value(synth->getRuntime().StateFile.c_str());
        } // Fl_Input* SessionStateFile
        { StateFileButton = new Fl_Button(401, 247, 49, 20, "Select");
          StateFileButton->box(FL_THIN_UP_BOX);
          StateFileButton->labelsize(12);
          StateFileButton->callback((Fl_Callback*)cb_StateFileButton);
          /* code */
        } // Fl_Button* StateFileButton
        { Fl_Counter* o = compression = new Fl_Counter(284, 170, 65, 20, "XML compression level");
          compression->tooltip("gzip compression level (0 - uncompressed)");
          compression->type(1);
          compression->minimum(0);
          compression->maximum(9);
          compression->step(1);
          compression->textsize(12);
          compression->callback((Fl_Callback*)cb_compression);
          compression->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().GzipCompression);
        } // Fl_Counter* compression
        { Fl_Choice* o = new Fl_Choice(203, 208, 150, 20, "Send reports to:");
          o->down_box(FL_BORDER_BOX);
          o->labelsize(12);
          o->textsize(13);
          o->callback((Fl_Callback*)cb_Send);
          o->menu(menu_Send);
          o->value(synth->getRuntime().consoleMenuItem);
        } // Fl_Choice* o
        { Fl_Box* o = new Fl_Box(100, 285, 267, 17, "Most settings changes require a restart");
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor((Fl_Color)38);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Box* o
        o->end();
      } // Fl_Group* o
      { Fl_Group* o = new Fl_Group(5, 25, 455, 272, "Presets dirs");
        o->labelsize(12);
        o->hide();
        { presetbrowse = new Fl_Browser(10, 35, 450, 200);
          presetbrowse->type(2);
          presetbrowse->labelsize(12);
          presetbrowse->textsize(12);
          presetbrowse->callback((Fl_Callback*)cb_presetbrowse);
        } // Fl_Browser* presetbrowse
        { Fl_Button* o = new Fl_Button(15, 244, 80, 35, "Add preset directory...");
          o->box(FL_THIN_UP_BOX);
          o->labelsize(12);
          o->callback((Fl_Callback*)cb_Add);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Button* o
        { Fl_Button* o = removepresetbutton = new Fl_Button(105, 244, 80, 35, "Remove preset dir...");
          removepresetbutton->box(FL_THIN_UP_BOX);
          removepresetbutton->labelsize(12);
          removepresetbutton->callback((Fl_Callback*)cb_removepresetbutton);
          removepresetbutton->align(Fl_Align(FL_ALIGN_WRAP));
          o->deactivate();
        } // Fl_Button* removepresetbutton
        { Fl_Button* o = makedefaultpresetbutton = new Fl_Button(190, 244, 80, 35, "Make default");
          makedefaultpresetbutton->box(FL_THIN_UP_BOX);
          makedefaultpresetbutton->labelsize(12);
          makedefaultpresetbutton->callback((Fl_Callback*)cb_makedefaultpresetbutton);
          makedefaultpresetbutton->align(Fl_Align(FL_ALIGN_WRAP));
          o->deactivate();
        } // Fl_Button* makedefaultpresetbutton
        { Fl_Box* o = new Fl_Box(110, 285, 267, 12, "Settings changes require a restart");
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor((Fl_Color)38);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Box* o
        o->end();
      } // Fl_Group* o
      { Fl_Group* o = new Fl_Group(5, 25, 455, 277, "Jack");
        o->labelsize(12);
        o->hide();
        { Fl_Input* o = new Fl_Input(218, 149, 100, 22, "Jack Server");
          o->tooltip("Name of the jack server to connect to - default, ...");
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_Jack);
          o->insert(synth->getRuntime().jackServer.c_str());
        } // Fl_Input* o
        { Fl_Box* o = new Fl_Box(110, 285, 267, 17, "Settings changes require a restart");
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor((Fl_Color)38);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Box* o
        o->end();
      } // Fl_Group* o
      { Fl_Group* o = new Fl_Group(5, 25, 455, 277, "Alsa");
        o->labelsize(12);
        o->hide();
        { Fl_Input* o = new Fl_Input(195, 52, 120, 22, "Alsa Midi Device");
          o->tooltip("Alsa midi device - default, hw:0, ...");
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_Alsa);
          o->insert(synth->getRuntime().alsaMidiDevice.c_str());
        } // Fl_Input* o
        { Fl_Input* o = new Fl_Input(195, 93, 120, 22, "Alsa Audio Device");
          o->tooltip("Alsa audio device - default, hw:0, front:CARD=Live,DEV=0, ...");
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_Alsa1);
          o->insert(synth->getRuntime().alsaAudioDevice.c_str());
        } // Fl_Input* o
        { Fl_Check_Browser* o = new Fl_Check_Browser(195, 131, 84, 50, "Samplerate");
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_Samplerate);
          o->align(Fl_Align(FL_ALIGN_LEFT));
          o->when(FL_WHEN_CHANGED);
          //
                o->add("96000");
                o->add("48000");
                o->add("44100");
                switch (synth->getRuntime().Samplerate)
                {
                    case 96000: o->set_checked(1); break;
                    case 44100: o->set_checked(3); break;
                    case 48000:
                    default: o->set_checked(2); break;
                }
        } // Fl_Check_Browser* o
        { Fl_Check_Browser* o = new Fl_Check_Browser(195, 195, 76, 73, "Period Size");
          o->labelsize(12);
          o->textsize(12);
          o->callback((Fl_Callback*)cb_Period);
          o->align(Fl_Align(FL_ALIGN_LEFT));
          o->when(FL_WHEN_CHANGED);
          //
                o->add("64");
                o->add("128");
                o->add("256");
                o->add("512");
                o->add("1024");
                switch (synth->getRuntime().Buffersize)
                {
                    case 64: o->set_checked(1); break;
                    case 128: o->set_checked(2); break;
                    case 256: o->set_checked(3); break;
                    case 512: o->set_checked(4); break;
                    case 1024: o->set_checked(5); break;
                    default: o->set_checked(4); break;
                }
        } // Fl_Check_Browser* o
        { Fl_Box* o = new Fl_Box(110, 285, 267, 17, "Settings changes require a restart");
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor((Fl_Color)38);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Box* o
        o->end();
      } // Fl_Group* o
      { Fl_Group* o = new Fl_Group(5, 25, 455, 275, "CCs");
        o->tooltip("MIDI CC preferences");
        o->labelsize(12);
        o->callback((Fl_Callback*)cb_CCs);
        { BankRootok = new Fl_Return_Button(275, 78, 85, 22, "Set");
          BankRootok->box(FL_NO_BOX);
          BankRootok->labelsize(12);
          BankRootok->callback((Fl_Callback*)cb_BankRootok);
          BankRootok->align(Fl_Align(FL_ALIGN_RIGHT));
          BankRootok->deactivate();
        } // Fl_Return_Button* BankRootok
        { Fl_Spinner* o = BankRoot = new Fl_Spinner(275, 81, 53, 18, "Bank Root Change");
          BankRoot->labelsize(12);
          BankRoot->minimum(0);
          BankRoot->maximum(127);
          BankRoot->value(0);
          BankRoot->textsize(12);
          BankRoot->callback((Fl_Callback*)cb_BankRoot);
          BankRootvalue = synth->getRuntime().midi_bank_root;
          if (BankRootvalue < 128) o->value(BankRootvalue); else o->value(0);
        } // Fl_Spinner* BankRoot
        { Fl_Check_Button* o = new Fl_Check_Button(275, 60, 18, 18, "Enable Bank Root Change");
          o->down_box(FL_DOWN_BOX);
          o->labelsize(12);
          o->callback((Fl_Callback*)cb_Enable);
          o->align(Fl_Align(FL_ALIGN_LEFT));
          o->value((synth->getRuntime().midi_bank_root < 128));
          if (o->value() == 0) { BankRoot->deactivate(); BankRootok->deactivate(); }
        } // Fl_Check_Button* o
        { Fl_Choice* o = bankchange = new Fl_Choice(275, 122, 60, 18, "Bank Change");
          bankchange->tooltip("CC0 = msb, CC32 = lsb");
          bankchange->down_box(FL_BORDER_BOX);
          bankchange->labelsize(12);
          bankchange->textsize(12);
          bankchange->callback((Fl_Callback*)cb_bankchange);
          bankchange->align(Fl_Align(132));
          bankchange->menu(menu_bankchange);
          if (synth->getRuntime().midi_bank_C == 32) o->value(0); else if (synth->getRuntime().midi_bank_C == 0) o->value(1); else o->value(2);
          oldBank = o->value();
        } // Fl_Choice* bankchange
        { Fl_Check_Button* o = new Fl_Check_Button(275, 162, 18, 18, "Enable Program Change");
          o->tooltip("MIDI program change enable/disable");
          o->down_box(FL_DOWN_BOX);
          o->value(1);
          o->labelsize(12);
          o->callback((Fl_Callback*)cb_Enable1);
          o->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().EnableProgChange);
        } // Fl_Check_Button* o
        { Fl_Check_Button* o = new Fl_Check_Button(275, 182, 18, 18, "Enable Part On Program Change");
          o->tooltip("Part enabled if MIDI program changed");
          o->down_box(FL_DOWN_BOX);
          o->labelsize(12);
          o->callback((Fl_Callback*)cb_Enable2);
          o->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().enable_part_on_voice_load);
        } // Fl_Check_Button* o
        { EPCok = new Fl_Return_Button(275, 238, 85, 22, "Set");
          EPCok->box(FL_NO_BOX);
          EPCok->labelsize(12);
          EPCok->callback((Fl_Callback*)cb_EPCok);
          EPCok->align(Fl_Align(FL_ALIGN_RIGHT));
          EPCok->deactivate();
        } // Fl_Return_Button* EPCok
        { Fl_Spinner* o = EPCspinner = new Fl_Spinner(275, 241, 53, 18, "Extended Program Change");
          EPCspinner->labelsize(12);
          EPCspinner->minimum(0);
          EPCspinner->maximum(127);
          EPCspinner->value(110);
          EPCspinner->textsize(12);
          EPCspinner->callback((Fl_Callback*)cb_EPCspinner);
          EPCvalue = synth->getRuntime().midi_upper_voice_C;
          if (EPCvalue < 128) o->value(EPCvalue); else o->value(110);
        } // Fl_Spinner* EPCspinner
        { Fl_Check_Button* o = new Fl_Check_Button(275, 220, 18, 18, "Enable Extended Program Change");
          o->down_box(FL_DOWN_BOX);
          o->labelsize(12);
          o->callback((Fl_Callback*)cb_Enable3);
          o->align(Fl_Align(FL_ALIGN_LEFT));
          o->value((synth->getRuntime().midi_upper_voice_C < 128));
          if (o->value() == 0) { EPCspinner->deactivate(); EPCok->deactivate(); }
        } // Fl_Check_Button* o
        EPCvalue = synth->getRuntime().midi_upper_voice_C;
        BankRootvalue = synth->getRuntime().midi_bank_root;
        o->end();
      } // Fl_Group* o
      o->end();
    } // Fl_Tabs* o
    { Fl_Button* o = new Fl_Button(345, 305, 105, 20, "Close Unsaved");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(225, 305, 105, 20, "Save and Close");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Save);
    } // Fl_Button* o
    configwindow->end();
  } // Fl_Double_Window* configwindow
  return configwindow;
}

ConfigUI::ConfigUI(SynthEngine *_synth) {
  //
  	synth = _synth;
          configChanged = false;
          make_window();
          readpresetcfg();
  	selectedRootID = -1;
}

void ConfigUI::activatebutton_presetdir(bool active) {
  //
          if (active)
          {
              removepresetbutton->activate();
              makedefaultpresetbutton->activate();
          }
          else
          {
              removepresetbutton->deactivate();
              makedefaultpresetbutton->deactivate();
          }
}

int ConfigUI::recoverID() {
  //
      if (selectedRootID >= 0)
      {
          return selectedRootID;
      }
      return 0;
}

void ConfigUI::readpresetcfg() {
  //
          presetbrowse->clear();
          for (int i = 0; i < MAX_BANK_ROOT_DIRS; ++i)
              if (synth->getRuntime().presetsDirlist[i].size())
                  presetbrowse->add(synth->getRuntime().presetsDirlist[i].c_str());
}

void ConfigUI::writepresetcfg() {
  //
          synth->getRuntime().clearPresetsDirlist();
          for (int n = 0; n < presetbrowse->size(); ++n)
              synth->getRuntime().presetsDirlist[n] = string(presetbrowse->text(n + 1));
}

void ConfigUI::Show() {
  configwindow->show();
}

void ConfigUI::Hide() {
  configwindow->hide();
}

void ConfigUI::savesettings(void) {
  //
          synth->getRuntime().saveConfig();
          writepresetcfg();
}
