// MicrotonalUI.h
// generated by Fast Light User Interface Designer (fluid) version 1.0303

#ifndef MicrotonalUI_h
#define MicrotonalUI_h
#include <FL/Fl.H>
// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009, Alan Calvert

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is a derivative of the ZynAddSubFX original, modified October 2009

#include <FL/Fl_File_Chooser.H>
#include <FL/fl_ask.H>
#include "Misc/Microtonal.h"
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Counter.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Value_Output.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Value_Input.H>

class MicrotonalUI {
public:
  Fl_Double_Window* make_window();
  Fl_Double_Window *microtonaluiwindow;
private:
  inline void cb_Invert_i(Fl_Check_Button*, void*);
  static void cb_Invert(Fl_Check_Button*, void*);
public:
  Fl_Counter *centerinvertcounter;
private:
  inline void cb_centerinvertcounter_i(Fl_Counter*, void*);
  static void cb_centerinvertcounter(Fl_Counter*, void*);
public:
  Fl_Group *microtonalgroup;
  Fl_Button *applybutton;
private:
  inline void cb_applybutton_i(Fl_Button*, void*);
  static void cb_applybutton(Fl_Button*, void*);
public:
  Fl_Value_Output *octavesizeoutput;
private:
  inline void cb_octavesizeoutput_i(Fl_Value_Output*, void*);
  static void cb_octavesizeoutput(Fl_Value_Output*, void*);
public:
  Fl_Input *nameinput;
private:
  inline void cb_nameinput_i(Fl_Input*, void*);
  static void cb_nameinput(Fl_Input*, void*);
public:
  Fl_Input *tuningsinput;
  Fl_Input *commentinput;
private:
  inline void cb_commentinput_i(Fl_Input*, void*);
  static void cb_commentinput(Fl_Input*, void*);
  inline void cb_Shift_i(Fl_Counter*, void*);
  static void cb_Shift(Fl_Counter*, void*);
  inline void cb_Import_i(Fl_Button*, void*);
  static void cb_Import(Fl_Button*, void*);
public:
  Fl_Group *keymappinggroup;
  Fl_Input *mappinginput;
  Fl_Counter *firstnotecounter;
private:
  inline void cb_firstnotecounter_i(Fl_Counter*, void*);
  static void cb_firstnotecounter(Fl_Counter*, void*);
public:
  Fl_Counter *lastnotecounter;
private:
  inline void cb_lastnotecounter_i(Fl_Counter*, void*);
  static void cb_lastnotecounter(Fl_Counter*, void*);
public:
  Fl_Counter *middlenotecounter;
private:
  inline void cb_middlenotecounter_i(Fl_Counter*, void*);
  static void cb_middlenotecounter(Fl_Counter*, void*);
public:
  Fl_Value_Output *mapsizeoutput;
private:
  inline void cb_mapsizeoutput_i(Fl_Value_Output*, void*);
  static void cb_mapsizeoutput(Fl_Value_Output*, void*);
public:
  Fl_Check_Button *mappingenabledbutton;
private:
  inline void cb_mappingenabledbutton_i(Fl_Check_Button*, void*);
  static void cb_mappingenabledbutton(Fl_Check_Button*, void*);
  inline void cb_Import1_i(Fl_Button*, void*);
  static void cb_Import1(Fl_Button*, void*);
public:
  Fl_Counter *anotecounter;
private:
  inline void cb_anotecounter_i(Fl_Counter*, void*);
  static void cb_anotecounter(Fl_Counter*, void*);
public:
  Fl_Value_Input *afreqinput;
private:
  inline void cb_afreqinput_i(Fl_Value_Input*, void*);
  static void cb_afreqinput(Fl_Value_Input*, void*);
  inline void cb_Close_i(Fl_Button*, void*);
  static void cb_Close(Fl_Button*, void*);
  inline void cb_Enable_i(Fl_Check_Button*, void*);
  static void cb_Enable(Fl_Check_Button*, void*);
public:
  void updateTuningsInput();
  void updateMappingInput();
  MicrotonalUI(Microtonal *microtonal_);
  ~MicrotonalUI();
  void Show();
  void Hide();
  void apply();
private:
  Microtonal *microtonal; 
};
#endif
